<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>jQuery UI Autocomplete - Remote JSONP datasource</title>
	<link rel="stylesheet" href="/assets/templates/css/themes/base/jquery.ui.all.css">
		
	<script type="text/javascript" src="/assets/templates/js/jquery-1.7.2.min.js"></script>
	<script src="/assets/templates/js/jquery-ui-1.8.23.custom.min.js"></script>
	<script src="/assets/templates/js/jquery.ui.core.min.js"></script>
	<script src="/assets/templates/js/jquery.ui.widget.min.js"></script>
	<script src="/assets/templates/js/jquery.ui.position.min.js"></script>
	<script src="/assets/templates/js/jquery.ui.autocomplete.min.js"></script>
	<link rel="stylesheet" href="../demos.css">
	<style>
	.ui-autocomplete-loading { background: white url('images/ui-anim_basic_16x16.gif') right center no-repeat; }
	#city { width: 25em; }
	</style>
	<script>
$(function() {
		function log( message ) {
			$( "<div/>" ).text( message ).prependTo( "#log" );
			$( "#log" ).scrollTop( 0 );
		}

		$( "#birds" ).autocomplete({
			source: "/sphinx.php",
			minLength: 3,
			select: function( event, ui ) {
				location.href='/stranicza-video.html?id='+ui.item.id;
			
		
			}
		});
	});
	</script>
</head>
<body>

<div class="demo">

<div class="ui-widget">
	<label for="birds">Your city: </label>
	<input id="birds" />
	Powered by <a href="http://geonames.org">geonames.org</a>
</div>

<div class="ui-widget" style="margin-top:2em; font-family:Arial">
	Result:
	<div id="log" style="height: 200px; width: 300px; overflow: auto;" class="ui-widget-content"></div>
</div>

</div><!-- End demo -->



<div class="demo-description">
<p>The Autocomplete widgets provides suggestions while you type into the field. Here the suggestions are cities, displayed when at least two characters are entered into the field.</p>
<p>In this case, the datasource is the <a href="http://geonames.org">geonames.org webservice</a>. While only the city name itself ends up in the input after selecting an element, more info is displayed in the suggestions to help find the right entry. That data is also available in callbacks, as illustrated by the Result area below the input.</p>
</div><!-- End demo-description -->

</body>
</html>
