<?php
/*
 * @package Joomla 3.0
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component
 * @copyright Copyright (C) Aleksandr Ermakov www.ermakovshop.com
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
jimport('joomla.plugin.helper');
jimport('joomla.html.parameter');
/**
* Foobar View
*/

class ejosearchViewejosearch extends JViewLegacy
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{

		require_once JPATH_COMPONENT.'/helpers/route.php';
		require_once JPATH_ADMINISTRATOR.'/components/com_ejoshop/libraries/ejoshop/photos/viewphotos.php';
		$viewphotos = new EjoshopViewPhotos();
		
		$app = JFactory::getApplication(); 

		$ejoshopparams = JComponentHelper::getParams( 'com_ejoshop' );
		$ejosearchmodule = JModuleHelper::getModule( 'ejosearch' );
		$this->keyword = JRequest::getVar('keyword',0);
		$this->type = JRequest::getVar('type',0);
		$this->idtype = JRequest::getVar('idtype',0);

		if(!$this->keyword) $this->keyword = JRequest::getVar('searchword');
		$routehelper = new EjosearchHelperRoute();
		$this->params = json_decode($ejosearchmodule->params);
		if($this->params->usesphinx) {
			$this->listresult = $this->searchresult(false, $this->keyword);
			$index = "ejoshop_product";
			
			$opts = array
			(
				"before_match"		=> "<b>",
				"after_match"		=> "</b>",
				"chunk_separator"	=> " ... ",
				"limit"				=> 60,
				"around"			=> 3,
			);
			$cl = new SphinxClient ();
			$cl->SetServer( "localhost" , 9306);
			
			foreach ($this->listresult as &$item) {
				
				$res = $cl->BuildExcerpts ( array($item->intro), $index, $this->keyword, $opts );
				
				if ( !$res )
				{
					
					echo "ERROR: " . $cl->GetLastError() . ".\n" ;
				} else
				{
					
					$item->intro = $res[0];
					
				}
			}
		} else {
			$p = $this->get('Pager');
			$this->pager = $p->getListFooter();
			$this->listresult = $this->getSuggestions($this->keyword);
			$this->total = $p->get('total');
		}
		
			foreach($this->listresult as &$item) {
			
				$item->detail = JRoute::_($routehelper->getArticleRoute($item->id, $item->catid));
				$item = $viewphotos->processItems($item, $sub = false,$ejoshopparams);
				$item->price_with_currency = str_replace('\$','$', $item->price_with_currency);
			}
			
		if(empty($this->tmpl)) $this->tmpl['action'] = '';
		parent::display($tpl);
	}

	
	function searchresult($json = FALSE,$keyword) {
	
		$q = trim( html_entity_decode( $keyword, ENT_QUOTES, 'UTF-8') ) ;
		
		$sphx = $this->sphinx_search($q, 0, 20);
	
		 
		if( empty($sphx['ids']) )
			return new StdClass();
		 
		$ids = $sphx['ids'];
		
		$app = JFactory::getApplication(); 
		$limit = $app->getUserStateFromRequest('ejosearch.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0);
		
		$sql =  "SELECT `cat` . * ,  `photos`.*, `fm` . *
					FROM `#__ejoshop_photos` as `photos`
					LEFT JOIN #__ejoshop_categories AS cat ON (photos.catid = cat.id)
					LEFT JOIN #__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)
					WHERE  `photos`.`id` in ( {$ids}  )
					ORDER BY FIELD(`photos`.`id`, {$ids} ) LIMIT $limitstart, $limit";
		
		
		$db		= JFactory::getDBO();

		try {
			$query = $db->setQuery( $sql );
			
			if (!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch (Exception $e) {
			echo $e->getMessage();
			
		}
		
		$r = $db->loadObjectList();
		$max = $sphx['total'];
		$num_rows = $sphx['docs'];
		
		$this->total = $this->getTotalResult($ids);
		$model = $this->getModel();

		$p = $model->getPager($max);
		$this->pager = $p->getListFooter();
		$this->total = $p->get('total');
		

		return $r;
		
	}

 
	/*
	 * SPHINX Search
	 */
	 
	/*
	 * Search sites by Keywords using sphinx; with an option to search sites tags only
	 * @param string $q te keyword
	 * @param int $i id of the first result to return
	 * @param int $max max results to return
	 * @param bollen $url set to true to return matches from the 'url' column only
	 * 
	 * @return string $ids comma seperated list of ids
	 */
	function sphinx_search($q, $i, $limit, $url=false){
			require_once JPATH_COMPONENT.'/helpers/searchsphinx/api/sphinxapi.php';
	 
			$ids = '';
	 
			$cl = new SphinxClient();
			$cl->SetServer( "localhost" , 9306);
			$cl->SetMatchMode( SPH_MATCH_ANY  );
			$cl->SetSortMode ( SPH_SORT_RELEVANCE );
			$cl->SetFieldWeights(array('name' => 100, 'intro' => 3000, 'phototext' => 4000, 'id' => 4000));
			$cl->SetLimits( $i , $limit);
			$q = $cl->EscapeString( $q);
	 
			//search url only
			$q = $url ? "@url {$q}" : $q;
	 
			$result = $cl->Query( $q, 'ejoshop_product ejoshop_productDelta' );
			$err = $cl->GetLastError();

			if ( $result === false )
					error_log( '[SPHINX]Query failed: ' . $cl->GetLastError() );
			elseif ( $cl->GetLastWarning() ) 
					error_log( '[SPHINX]WARNING: ' .  $cl->GetLastWarning() );
	 
			if ( !empty($result["matches"]) ){
				foreach ( $result["matches"] as $doc => $docinfo ) 
					 $ids .= "$doc,";
				$ids = substr( $ids, 0, -1 );
		   }else
			   return false;
	 
		   return  array( 'ids' => $ids, 'total' => $result['total'], 'docs' => count($result["matches"])  );
	 
	}	
	
	
	public function getTotalResult($ids)
	{
	
	
		$sql =  "SELECT COUNT(*)
				FROM `#__ejoshop_photos` as `photos`
				LEFT JOIN #__ejoshop_categories AS cat ON (photos.catid = cat.id)
				LEFT JOIN #__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)
				WHERE  `photos`.`id` in ( {$ids}  )
				ORDER BY FIELD(`photos`.`id`, {$ids} )";
		
		$db		= JFactory::getDBO();

		try {
			$query = $db->setQuery( $sql );
			
			if (!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch (Exception $e) {
			echo $e->getMessage();
			die();
		}
		$r = $db->loadResult();
		
		return $r;
	}
	
	
	public function getSuggestions($keyword)
	{
		// escape the keyword string      
	
		$replace = array('');
	
		// build the SQL query that gets the matching functions from the database
		
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		
		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('photos.*, cat.title as category_name,cat.id as category_id,cat.alias as catalias,fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		
		$query->where("photos.name LIKE '" . $keyword . "%' OR photos.intro LIKE '%" . $keyword . "%'");
		$app = JFactory::getApplication(); 
		$limit = $app->getUserStateFromRequest('ejosearch.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0);

		
		$query = $db->setQuery( $query,$limitstart, $limit );
		$result = $db->loadObjectList();

		return $result;  
	}
	

}
?>