<?php
/*
 * @package		Joomla.Framework
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 *
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License version 2 or later;
 */
defined('_JEXEC') or die();
if (! class_exists('EjoshopLoader')) {
    require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'libraries'.DS.'loader.php');
}

class JFormFieldSphinxInstall extends JFormField
{
	protected $type 		= 'Info';

	function getLabel() {
		return JText::_($this->element['description']);
	}

	function getInput() {
	
		$config = JFactory::getConfig($_SERVER['DOCUMENT_ROOT'].JURI::root(true).'configuration.php');
		
		$out  = '<strong>'.JTEXT::_('COM_EJ_USESPHINX_FAQ').'</strong><br />';
		$out .= '<strong>'.JTEXT::_('COM_EJ_USESPHINX_FAQ_SEARCHD').'</strong><br />';
		
		$out .= 
		str_replace('#__',$config->get('dbprefix'), '<pre>
		# START ejoshop_product for EJOSHOP
		source ejoshop_product
		{
			# data source type. mandatory, no default value
			# known types are mysql, pgsql, mssql, xmlpipe, xmlpipe2, odbc
			type                    = mysql

			#####################################################################
			## SQL settings (for \'mysql\' and \'pgsql\' types)
			#####################################################################

			# some straightforward parameters for SQL source types
			sql_host                = '.$config->get('host').'
			sql_user                = '.$config->get('user').'
			sql_pass                = '.$config->get('password').'
			sql_db                  = '.$config->get('db').'
			#sql_port               = 3306    # optional, default is 3306

			sql_query_pre = SET NAMES utf8
			sql_query_post = SET CHARACTER SET utf8
			sql_query_pre = SET SESSION query_cache_type=OFF

			sql_query_pre = REPLACE INTO #__sphinxproduct_counter SELECT 1, MAX(id) FROM #__ejoshop_photos
			sql_query = SELECT id, name, intro, phototext FROM #__ejoshop_photos \
				WHERE id<=( SELECT max_doc_id FROM #__sphinxproduct_counter WHERE counter_id=1 )
		}

		source ejoshop_productDelta : ejoshop_product
		{
			sql_query_pre = SET NAMES utf8
			sql_query = SELECT id, name, intro, phototext FROM #__ejoshop_photos \
				WHERE id>( SELECT max_doc_id FROM #__sphinxproduct_counter WHERE counter_id=1 )
		}

		index ejoshop_product
		{
			source = ejoshop_product
			path = '.$_SERVER['DOCUMENT_ROOT'].'/data/sphinx/data/ejoshop_product
			# ... all the other settings
			morphology = stem_enru, soundex, metaphone
			# Кодировака данных из источника
			charset_type = utf-8

			#minimum indexed word length

			# default is 1 (index everything)
			min_word_len        = 3

			# minimum word infix length to index
			# optional, default is 0 (do not index infixes)
			#
			min_infix_len        = 3

			# enable star-syntax (wildcards) when searching prefix/infix indexes
			# known values are 0 and 1
			# optional, default is 0 (do not use wildcard syntax)
			#
			enable_star        = 1

			#enable chinese search
			ngram_len                                      = 1

		}

		# note how all other settings are copied from main,
		# but source and path are overridden (they MUST be)
		index ejoshop_productDelta : ejoshop_product
		{
			source = ejoshop_productDelta
			path = '.$_SERVER['DOCUMENT_ROOT'].'/data/sphinx/data/ejoshop_productDelta
			enable_star = 1
		}

		# START ejoshop_product for EJOSHOP

		# --eof--



		</pre>');
		return $out;
	}
}
?>