<?php
/**
 * @package     Joomla.Site
 * @subpackage  mod_search
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

// Include the syndicate functions only once
require_once __DIR__ . '/helper.php';

$lang = JFactory::getLanguage();
$app  = JFactory::getApplication();
$doc = JFactory::getDocument();

$scriptvar = "
/* URL to the PHP page called for receiving suggestions for a keyword*/
var getFunctionsUrl = '".JURI::root(true)."/index.php?option=com_ejosearch&view=getsuggest&format=row&keyword=';
/* URL for seeing the results for the selected suggestion */
var phpHelpUrl= '".JURI::base()."index.php?option=com_ejosearch&keyword=';

";

$doc->addScriptDeclaration($scriptvar);

$doc->addScript(JURI::root(true) . '/media/mod_ejosearch/assets/suggest.js');
$doc->addScript(JURI::root(true) . '/media/mod_ejosearch/assets/effects.js');
$doc->addStylesheet(JURI::root(true) . '/media/mod_ejosearch/assets/suggest.css');



$button			= $params->get('button', 0);
$imagebutton	= $params->get('imagebutton', 0);
$button_pos		= $params->get('button_pos', 'left');
$button_text	= htmlspecialchars($params->get('button_text', JText::_('MOD_EJOSEARCH_SEARCHBUTTON_TEXT')));
$width			= (int) $params->get('width', 20);
$maxlength		= 200;
$text			= htmlspecialchars($params->get('text', JText::_('MOD_EJOSEARCH_SEARCHBOX_TEXT')));
$label			= htmlspecialchars($params->get('label', JText::_('MOD_EJOSEARCH_LABEL_TEXT')));
$set_Itemid		= (int) $params->get('set_itemid', 0);
$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));
$keyword = JRequest::getVar('keyword',0);
$searchword = JRequest::getVar('searchword',0);

if(!$searchword && $keyword) {
	$searchword = $keyword;
} else if(!$searchword){
	$searchword = $text;
}

if ($imagebutton)
{
	$img = ModSearchHelper::getSearchImage($button_text);
}
$mitemid = $set_Itemid > 0 ? $set_Itemid : $app->input->get('Itemid');
require JModuleHelper::getLayoutPath('mod_ejosearch', $params->get('layout', 'default'));
